\ Copyright (c) 2005 by Offete Enterprises
\ All rights reserved 
\
\   Define required MMR Base value and offsets

$80020 org
': ADI_UNDEF_Interrupt
	[-T] R13, { R0, R1, R2, R3, R4, R5, R6, R7, R12, R14 }	,STMFD	
\	My_UNDEF_Function					,BL
\	0							,BL
	[-T] R13, { R0, R1, R2, R3, R4, R5, R6, R7, R12, R14 }	,LDMFD	
	S, PC, R14						,MOV	

': ADI_SWI_Interrupt
	[-T] R13, { R0, R1, R2, R3, R4, R5, R6, R7, R12, R14 }	,STMFD	
\	My_SWI_Function						,BL
\	0							,BL
	[-T] R13, { R0, R1, R2, R3, R4, R5, R6, R7, R12, R14 }	,LDMFD	
	S, PC, R14						,MOV	

': ADI_PABORT_Interrupt
	[-T] R13, { R0, R1, R2, R3, R4, R5, R6, R7, R12, R14 }	,STMFD	
\	My_PABORT_Function					,BL
\	0							,BL
	[-T] R13, { R0, R1, R2, R3, R4, R5, R6, R7, R12, R14 }	,LDMFD	
	S, PC, R14, 4 #						,SUB	

': ADI_DABORT_Interrupt
	[-T] R13, { R0, R1, R2, R3, R4, R5, R6, R7, R12, R14 }	,STMFD	
\	My_DABORT_Function					,BL
\	0							,BL
	[-T] R13, { R0, R1, R2, R3, R4, R5, R6, R7, R12, R14 }	,LDMFD	
	S, PC, R14, 8 #						,SUB	

': ADI_IRQ_Interrupt
	[-T] R13, { R0, R14 }					,STMFD	
\	My_IRQ_Function						,BL
\	0							,BL
	[-T] R13, { R0, R14 }					,LDMFD	
	S, PC, R14, 4 #						,SUB	

': ADI_FIQ_Interrupt
	[-T] R13, { R0, R1, R2, R3, R4, R5, R6, R7, R12, R14 }	,STMFD	
\	My_FIQ_Function						,BL
\	0							,BL
	[-T] R13, { R0, R1, R2, R3, R4, R5, R6, R7, R12, R14 }	,LDMFD	
	S, PC, R14, 4 #						,SUB	

': Reset_Handler  
	R0, $10000 #                	,MVN        \ FFFEFFFF
	R1, $1 #                   	,MOV        \ 
	[P] R1, R0, POWKEY1_OFFSET #	,STR        \ FFFF0404
	R1, PLLCFG_Val #		,MOV        \ DLAB access COMDIV0/COMDIV1
	[P] R1, R0, POWCON_OFFSET #	,STR        \ FFFF0408
	R1, $f4 #                   	,MOV        \ COMDIV0 ADuC7020 Rev. H
	[P] R1, R0, POWKEY2_OFFSET #	,STR        \ FFFF040C
\ Setup Stack for each mode 
	R0, $12000 #                   	,MOV        \ 
\  Enter Undefined Instruction Mode and set its Stack Pointer 
	CPSR, $DB #                 	,MSR     
	R13, R0                 	,MOV     
	R0, R0, UNDEF_Stack_Size #	,SUB      
\  Enter Abort Mode and set its Stack Pointer 
	CPSR, $D7 #			,MSR      
	R13, R0				,MOV      
	R0, R0, ABT_Stack_Size #	,SUB      
\  Enter FIQ Mode and set its Stack Pointer 
	CPSR, $D1 #			,MSR      
	R13, R0				,MOV     
	R0, R0, FIQ_Stack_Size #	,SUB     
\  Enter IRQ Mode and set its Stack Pointer 
	CPSR, $D2 #			,MSR      
	R13, R0				,MOV     
	R0, R0, IRQ_Stack_Size #	,SUB     
\  Enter Supervisor Mode and set its Stack Pointer 
	CPSR, $D3 #			,MSR      
	R13, R0				,MOV     
	R0, R0, SVC_Stack_Size #	,SUB     
\  Enter User Mode and set its Stack Pointer 
	CPSR, $10 #			,MSR      
	R13, R0				,MOV     
\  Setup a default Stack Limit (when compiled with -mapcs-stack-check) 
	R0, USR_Stack_Size #		,MOV     
	R10, R13, R0			,SUB	\ USER STACK SIZE SL = R10 */ 
\ Enter the standard system startup code required for stdlib I/O  
	' COLD				,B       	

80000 org
' Reset_Handler				,B
' ADI_UNDEF_Interrupt			,B 
' ADI_SWI_Interrupt			,B
' ADI_PABORT_Interrupt			,B 
' ADI_DABORT_Interrupt			,B 
' Reset_Handler				,B
' ADI_IRQ_Interrupt			,B
' ADI_FIQ_Interrupt			,B 

